% ڣ9.19
% ܣʵϸڹµ״仯
% Ľ
% 

% Author: Ling Xintong
% email :lim3300@163.com
% $Revision: 1.0.0.0 $  $Date: 2012/09/19 21:36 $
% CopyRight Reserved
clc
clear all
close all

%% Initial Parameter
InitialPara_MacroV1;

%% Set Bound
Bound_MacroV1;

%% Plot
PlotCell_MacroV1;
% subplot(221);
% text(numx*1.2,-numy*0.1,'Init State');
title('Init State');
print(gcf,'-djpeg',strcat('0.jpeg'));
pause(0.1);

%% Get Light Points
numLight=5;%յ
ra=8;
theta=linspace(0,2*pi,numLight+1);
theta(numLight+1)=[];
lp=[round(ra.*cos(theta)+xc);round(ra.*sin(theta)+yc)]';

% lp=round(ginput(numLight));
% lp=[70,65;87,76;70,83];
% lp=[xc+3,yc;xc-3,yc];
% lp=[xc+3,yc];
%% Main Cycle
for nt=1:Tmax
    tmpNumCell=zeros(numx,numy);
    tmpNumGreen=zeros(numx,numy);
    tmpNumRed=zeros(numx,numy);
    %% Plot
    if(mod(nt,1)==0)
        PlotCell_MacroV1;
        txt=sprintf('Step %d',nt);
        title(txt);
%         print(gcf,'-djpeg',strcat(num2str(nt),'.jpeg'));

%         subplot(221)        
%         text(numx*1.2,-numy*0.1,txt);
        pause(0.1);
    end
    
    %% AHL Diffusion
    AHLDiffusion_MacroV1;
    
    %% Red Cell Movement
    
    %     for nx=1:numx
    %         for ny=1:numy
    %             if(boundArray(nx,ny)==0)||(numCell(nx,ny)==0)
    %                 continue;
    %             end
    %             %             s=maxSigma-(maxSigma-1)*AHL(nx,ny)/maxAHL;
    %             %             if(s<1)
    %             %                 s=1;
    %             %             end
    %             mu=[nx,ny];
    %             sigmaMatrix=[greenSigma 0;0 greenSigma];
    %             [X,Y]=meshgrid(1:numx,1:numy); % ݲ
    %             p=mvnpdf([X(:),Y(:)],mu,sigmaMatrix);
    %             P=reshape(p,size(X))/sum(sum(P)); % ȡϸܶ
    %             tmpNumRed=tmpNumRed+P.*numRed(nx,ny);
    %         end
    %     end
    %     numRed=tmpNumRed.*boundAHL;
    %     numCell=numRed+numGreen;
    
    %% Green Cell Movement
    d=3*greenSigma;
    mu=[0,0];
    sigmaMatrix=[greenSigma 0;0 greenSigma];
    for nx=1:numx
        for ny=1:numy
            if(boundArray(nx,ny)==0)||(numCell(nx,ny)==0)
                continue;
            end
            
            minx=max(nx-d,1);
            miny=max(ny-d,1);
            maxx=min(nx+d,numx);
            maxy=min(ny+d,numy);
            mu=[nx,ny];
            [X,Y]=meshgrid(minx:maxx,miny:maxy); % ݲ
            p=mvnpdf([X(:),Y(:)],mu,sigmaMatrix);
            P=reshape(p,size(X'))/sum(sum(p)); % ȡϸܶ
            tmpNumGreen(minx:maxx,miny:maxy)=tmpNumGreen(minx:maxx,miny:maxy)+P.*numGreen(nx,ny);
        end
    end
    numGreen=tmpNumGreen.*boundAHL;
    numCell=numRed+numGreen;
    
    %% Cell Growth
    CellGrowth_MacroV1;
    
    %% Light
    for nlp=1:numLight
        numRed(lp(nlp,1),lp(nlp,2))=...
            numRed(lp(nlp,1),lp(nlp,2))+numGreen(lp(nlp,1),lp(nlp,2));
        numGreen(lp(nlp,1),lp(nlp,2))=0;
        numCell(lp(nlp,1),lp(nlp,2))=numRed(lp(nlp,1),lp(nlp,2));
    end
end
