% ܣʵϸڹµ״仯
% Ľ
%     ͼΧ

% Author: Ling Xintong
% email :lim3300@163.com 
% $Revision: 1.0.0.0 $  $Date: 2012/09/18 $
% CopyRight Reserved

clc
clear all
close all

%% Initial Parameter
InitialPara_ModelV1;

%%  Set Bound
Bound_MicroV1

%% Initial Cells
cellMatrix=zeros(numx,numy);
for nCell=1:initNumCell
    while(1)
        tx=xc;
        ty=yc;
        if(initBoundArray(tx,ty)==1)
            break;
        end
    end
    cellMatrix(tx,ty)=1;
end

%%
[rowRed,colRed]=find(mod(cellMatrix,tch)==2);
numRedCell=length(rowRed);
[rowGreen,colGreen]=find(mod(cellMatrix,tch)==1);
numGreenCell=length(rowGreen);

%% Init Plot
PlotCell_MicroV1;
txt=sprintf('Init State  Number of Cell=%d',numGreenCell+numRedCell);
title(txt);
print(gcf,'-djpeg',strcat('0.jpeg'));
pause(0.1);

%% Get Light Points
% lp=ginput(numLight);
%lp=[70,65;87,76;70,83];
numLight=5;%յ
ra=25;
theta=linspace(0,2*pi,numLight+1);
theta(numLight+1)=[];
lp=round([ra.*cos(theta)+xc;ra.*sin(theta)+yc]');
lightLength=2;
%%
for nt=1:Tmax
    [rowRed,colRed]=find(mod(cellMatrix,tch)==2);
    numRedCell=length(rowRed);
    [rowGreen,colGreen]=find(mod(cellMatrix,tch)==1);
    numGreenCell=length(rowGreen);
    tNumCell(nt)=length(find(cellMatrix>0));
    %% PLOT
    if(mod(nt,5)==0)
        PlotCell_MicroV1;
        txt=sprintf('step=%d  number of cell=%d',nt,numGreenCell+numRedCell);
        title(txt);
        print(gcf,'-djpeg',strcat(num2str(nt),'.jpeg'));
        pause(0.1);
    end
    %% Update Cell State
    
    for nx=1:numx
        for ny=1:numy
            if(cellMatrix(nx,ny)~=0) && (cellMatrix(nx,ny)<tr)
                cellMatrix(nx,ny)=cellMatrix(nx,ny)+tch;
            end
        end
    end
    
    %% AHL Diffusion
    AHLDiffusion_MicroV1;
    
    %% Red Cells Movement
    
    %% Green Cell Movement
    GreenMove_AutoMicroV1;
        
    %% Cell Division
    Division_ControledMicroV1;
    
    %% Cell Death
%     CellDeath_MicroV1;
end

% hold off
% figure
% plot(1:nt,tNumCell(1:nt),'k','linewidth',2)
% xlabel('Time')
% ylabel('Number of Cell')
% title('Cell Growth Curve')
% set(gcf,'color','w');
% print(gcf,'-djpeg','Cell Growth Curve.jpeg');