clc
clear all
close all

maxCell=100;
Tmax=250;
t=1:1:Tmax;
previousCell=200;
Nd=zeros(1,length(t));
curCell=zeros(1,length(t)+1);
curCell(1)=previousCell;
for nt=1:length(t)
    Nd(nt)=LogisticModel(curCell((nt)),maxCell);
    curCell(nt+1)=Nd((nt))+curCell((nt));
end
hold on
plot([t(1),t(length(t))],[maxCell,maxCell],'k-.','linewidth',1);
plot(t,Nd,'k--','linewidth',3);
plot(t,curCell(2:length(t)+1),'k-','linewidth',3);
set(gcf,'color','w');
xlabel('t/Step');
ylabel('Num of Cell');
title('Logistic Curve');
legend('Environment Capacity=100','Number Change Curve','Number of Cell')
% axis([0 max(t) 0 maxCell*1.3])